/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifndef __CSM_EXPORTED_MANAGER_H__
#define __CSM_EXPORTED_MANAGER_H__

#include <gio/gio.h>

G_BEGIN_DECLS


/* ------------------------------------------------------------------------ */
/* Declarations for org.gnome.SessionManager */

#define CSM_TYPE_EXPORTED_MANAGER (csm_exported_manager_get_type ())
#define CSM_EXPORTED_MANAGER(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), CSM_TYPE_EXPORTED_MANAGER, CsmExportedManager))
#define CSM_IS_EXPORTED_MANAGER(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), CSM_TYPE_EXPORTED_MANAGER))
#define CSM_EXPORTED_MANAGER_GET_IFACE(o) (G_TYPE_INSTANCE_GET_INTERFACE ((o), CSM_TYPE_EXPORTED_MANAGER, CsmExportedManagerIface))

struct _CsmExportedManager;
typedef struct _CsmExportedManager CsmExportedManager;
typedef struct _CsmExportedManagerIface CsmExportedManagerIface;

struct _CsmExportedManagerIface
{
  GTypeInterface parent_iface;



  gboolean (*handle_can_shutdown) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_get_clients) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_get_inhibitors) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_inhibit) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_app_id,
    guint arg_toplevel_xid,
    const gchar *arg_reason,
    guint arg_flags);

  gboolean (*handle_initialization_error) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_message,
    gboolean arg_fatal);

  gboolean (*handle_is_autostart_condition_handled) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_condition);

  gboolean (*handle_is_inhibited) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    guint arg_flags);

  gboolean (*handle_is_session_running) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_logout) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    guint arg_mode);

  gboolean (*handle_reboot) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_register_client) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_app_id,
    const gchar *arg_client_startup_id);

  gboolean (*handle_request_reboot) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_request_shutdown) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_setenv) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_variable,
    const gchar *arg_value);

  gboolean (*handle_shutdown) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

  gboolean (*handle_uninhibit) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    guint arg_inhibit_cookie);

  gboolean (*handle_unregister_client) (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_client_id);

  guint  (*get_inhibited_actions) (CsmExportedManager *object);

  const gchar * (*get_session_name) (CsmExportedManager *object);

  void (*client_added) (
    CsmExportedManager *object,
    const gchar *arg_id);

  void (*client_removed) (
    CsmExportedManager *object,
    const gchar *arg_id);

  void (*inhibitor_added) (
    CsmExportedManager *object,
    const gchar *arg_id);

  void (*inhibitor_removed) (
    CsmExportedManager *object,
    const gchar *arg_id);

  void (*session_over) (
    CsmExportedManager *object);

  void (*session_running) (
    CsmExportedManager *object);

};

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CsmExportedManager, g_object_unref)
#endif

GType csm_exported_manager_get_type (void) G_GNUC_CONST;

GDBusInterfaceInfo *csm_exported_manager_interface_info (void);
guint csm_exported_manager_override_properties (GObjectClass *klass, guint property_id_begin);


/* D-Bus method call completion functions: */
void csm_exported_manager_complete_setenv (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

void csm_exported_manager_complete_initialization_error (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

void csm_exported_manager_complete_register_client (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *client_id);

void csm_exported_manager_complete_unregister_client (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

void csm_exported_manager_complete_inhibit (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    guint inhibit_cookie);

void csm_exported_manager_complete_uninhibit (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

void csm_exported_manager_complete_is_inhibited (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    gboolean is_inhibited);

void csm_exported_manager_complete_get_clients (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *const *clients);

void csm_exported_manager_complete_get_inhibitors (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    const gchar *const *inhibitors);

void csm_exported_manager_complete_is_autostart_condition_handled (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    gboolean handled);

void csm_exported_manager_complete_shutdown (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

void csm_exported_manager_complete_reboot (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

void csm_exported_manager_complete_can_shutdown (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    gboolean is_available);

void csm_exported_manager_complete_logout (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

void csm_exported_manager_complete_is_session_running (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation,
    gboolean running);

void csm_exported_manager_complete_request_shutdown (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);

void csm_exported_manager_complete_request_reboot (
    CsmExportedManager *object,
    GDBusMethodInvocation *invocation);



/* D-Bus signal emissions functions: */
void csm_exported_manager_emit_client_added (
    CsmExportedManager *object,
    const gchar *arg_id);

void csm_exported_manager_emit_client_removed (
    CsmExportedManager *object,
    const gchar *arg_id);

void csm_exported_manager_emit_inhibitor_added (
    CsmExportedManager *object,
    const gchar *arg_id);

void csm_exported_manager_emit_inhibitor_removed (
    CsmExportedManager *object,
    const gchar *arg_id);

void csm_exported_manager_emit_session_running (
    CsmExportedManager *object);

void csm_exported_manager_emit_session_over (
    CsmExportedManager *object);



/* D-Bus method calls: */
void csm_exported_manager_call_setenv (
    CsmExportedManager *proxy,
    const gchar *arg_variable,
    const gchar *arg_value,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_setenv_finish (
    CsmExportedManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_setenv_sync (
    CsmExportedManager *proxy,
    const gchar *arg_variable,
    const gchar *arg_value,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_initialization_error (
    CsmExportedManager *proxy,
    const gchar *arg_message,
    gboolean arg_fatal,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_initialization_error_finish (
    CsmExportedManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_initialization_error_sync (
    CsmExportedManager *proxy,
    const gchar *arg_message,
    gboolean arg_fatal,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_register_client (
    CsmExportedManager *proxy,
    const gchar *arg_app_id,
    const gchar *arg_client_startup_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_register_client_finish (
    CsmExportedManager *proxy,
    gchar **out_client_id,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_register_client_sync (
    CsmExportedManager *proxy,
    const gchar *arg_app_id,
    const gchar *arg_client_startup_id,
    gchar **out_client_id,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_unregister_client (
    CsmExportedManager *proxy,
    const gchar *arg_client_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_unregister_client_finish (
    CsmExportedManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_unregister_client_sync (
    CsmExportedManager *proxy,
    const gchar *arg_client_id,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_inhibit (
    CsmExportedManager *proxy,
    const gchar *arg_app_id,
    guint arg_toplevel_xid,
    const gchar *arg_reason,
    guint arg_flags,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_inhibit_finish (
    CsmExportedManager *proxy,
    guint *out_inhibit_cookie,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_inhibit_sync (
    CsmExportedManager *proxy,
    const gchar *arg_app_id,
    guint arg_toplevel_xid,
    const gchar *arg_reason,
    guint arg_flags,
    guint *out_inhibit_cookie,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_uninhibit (
    CsmExportedManager *proxy,
    guint arg_inhibit_cookie,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_uninhibit_finish (
    CsmExportedManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_uninhibit_sync (
    CsmExportedManager *proxy,
    guint arg_inhibit_cookie,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_is_inhibited (
    CsmExportedManager *proxy,
    guint arg_flags,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_is_inhibited_finish (
    CsmExportedManager *proxy,
    gboolean *out_is_inhibited,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_is_inhibited_sync (
    CsmExportedManager *proxy,
    guint arg_flags,
    gboolean *out_is_inhibited,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_get_clients (
    CsmExportedManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_get_clients_finish (
    CsmExportedManager *proxy,
    gchar ***out_clients,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_get_clients_sync (
    CsmExportedManager *proxy,
    gchar ***out_clients,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_get_inhibitors (
    CsmExportedManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_get_inhibitors_finish (
    CsmExportedManager *proxy,
    gchar ***out_inhibitors,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_get_inhibitors_sync (
    CsmExportedManager *proxy,
    gchar ***out_inhibitors,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_is_autostart_condition_handled (
    CsmExportedManager *proxy,
    const gchar *arg_condition,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_is_autostart_condition_handled_finish (
    CsmExportedManager *proxy,
    gboolean *out_handled,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_is_autostart_condition_handled_sync (
    CsmExportedManager *proxy,
    const gchar *arg_condition,
    gboolean *out_handled,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_shutdown (
    CsmExportedManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_shutdown_finish (
    CsmExportedManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_shutdown_sync (
    CsmExportedManager *proxy,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_reboot (
    CsmExportedManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_reboot_finish (
    CsmExportedManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_reboot_sync (
    CsmExportedManager *proxy,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_can_shutdown (
    CsmExportedManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_can_shutdown_finish (
    CsmExportedManager *proxy,
    gboolean *out_is_available,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_can_shutdown_sync (
    CsmExportedManager *proxy,
    gboolean *out_is_available,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_logout (
    CsmExportedManager *proxy,
    guint arg_mode,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_logout_finish (
    CsmExportedManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_logout_sync (
    CsmExportedManager *proxy,
    guint arg_mode,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_is_session_running (
    CsmExportedManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_is_session_running_finish (
    CsmExportedManager *proxy,
    gboolean *out_running,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_is_session_running_sync (
    CsmExportedManager *proxy,
    gboolean *out_running,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_request_shutdown (
    CsmExportedManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_request_shutdown_finish (
    CsmExportedManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_request_shutdown_sync (
    CsmExportedManager *proxy,
    GCancellable *cancellable,
    GError **error);

void csm_exported_manager_call_request_reboot (
    CsmExportedManager *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean csm_exported_manager_call_request_reboot_finish (
    CsmExportedManager *proxy,
    GAsyncResult *res,
    GError **error);

gboolean csm_exported_manager_call_request_reboot_sync (
    CsmExportedManager *proxy,
    GCancellable *cancellable,
    GError **error);



/* D-Bus property accessors: */
const gchar *csm_exported_manager_get_session_name (CsmExportedManager *object);
gchar *csm_exported_manager_dup_session_name (CsmExportedManager *object);
void csm_exported_manager_set_session_name (CsmExportedManager *object, const gchar *value);

guint csm_exported_manager_get_inhibited_actions (CsmExportedManager *object);
void csm_exported_manager_set_inhibited_actions (CsmExportedManager *object, guint value);


/* ---- */

#define CSM_TYPE_EXPORTED_MANAGER_PROXY (csm_exported_manager_proxy_get_type ())
#define CSM_EXPORTED_MANAGER_PROXY(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), CSM_TYPE_EXPORTED_MANAGER_PROXY, CsmExportedManagerProxy))
#define CSM_EXPORTED_MANAGER_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), CSM_TYPE_EXPORTED_MANAGER_PROXY, CsmExportedManagerProxyClass))
#define CSM_EXPORTED_MANAGER_PROXY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), CSM_TYPE_EXPORTED_MANAGER_PROXY, CsmExportedManagerProxyClass))
#define CSM_IS_EXPORTED_MANAGER_PROXY(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), CSM_TYPE_EXPORTED_MANAGER_PROXY))
#define CSM_IS_EXPORTED_MANAGER_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), CSM_TYPE_EXPORTED_MANAGER_PROXY))

typedef struct _CsmExportedManagerProxy CsmExportedManagerProxy;
typedef struct _CsmExportedManagerProxyClass CsmExportedManagerProxyClass;
typedef struct _CsmExportedManagerProxyPrivate CsmExportedManagerProxyPrivate;

struct _CsmExportedManagerProxy
{
  /*< private >*/
  GDBusProxy parent_instance;
  CsmExportedManagerProxyPrivate *priv;
};

struct _CsmExportedManagerProxyClass
{
  GDBusProxyClass parent_class;
};

GType csm_exported_manager_proxy_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CsmExportedManagerProxy, g_object_unref)
#endif

void csm_exported_manager_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
CsmExportedManager *csm_exported_manager_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error);
CsmExportedManager *csm_exported_manager_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);

void csm_exported_manager_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
CsmExportedManager *csm_exported_manager_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error);
CsmExportedManager *csm_exported_manager_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);


/* ---- */

#define CSM_TYPE_EXPORTED_MANAGER_SKELETON (csm_exported_manager_skeleton_get_type ())
#define CSM_EXPORTED_MANAGER_SKELETON(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), CSM_TYPE_EXPORTED_MANAGER_SKELETON, CsmExportedManagerSkeleton))
#define CSM_EXPORTED_MANAGER_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), CSM_TYPE_EXPORTED_MANAGER_SKELETON, CsmExportedManagerSkeletonClass))
#define CSM_EXPORTED_MANAGER_SKELETON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), CSM_TYPE_EXPORTED_MANAGER_SKELETON, CsmExportedManagerSkeletonClass))
#define CSM_IS_EXPORTED_MANAGER_SKELETON(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), CSM_TYPE_EXPORTED_MANAGER_SKELETON))
#define CSM_IS_EXPORTED_MANAGER_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), CSM_TYPE_EXPORTED_MANAGER_SKELETON))

typedef struct _CsmExportedManagerSkeleton CsmExportedManagerSkeleton;
typedef struct _CsmExportedManagerSkeletonClass CsmExportedManagerSkeletonClass;
typedef struct _CsmExportedManagerSkeletonPrivate CsmExportedManagerSkeletonPrivate;

struct _CsmExportedManagerSkeleton
{
  /*< private >*/
  GDBusInterfaceSkeleton parent_instance;
  CsmExportedManagerSkeletonPrivate *priv;
};

struct _CsmExportedManagerSkeletonClass
{
  GDBusInterfaceSkeletonClass parent_class;
};

GType csm_exported_manager_skeleton_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CsmExportedManagerSkeleton, g_object_unref)
#endif

CsmExportedManager *csm_exported_manager_skeleton_new (void);


G_END_DECLS

#endif /* __CSM_EXPORTED_MANAGER_H__ */
